import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkOldCard, ThinkOldCardParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询旧运动时卡
 */
export async function pageThinkOldCard(params: ThinkOldCardParam) {
  const res = await request.get<ApiResult<PageResult<ThinkOldCard>>>(
    THINK_API_URL + '/think/think-old-card/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询旧运动时卡列表
 */
export async function listThinkOldCard(params?: ThinkOldCardParam) {
  const res = await request.get<ApiResult<ThinkOldCard[]>>(
    THINK_API_URL + '/think/think-old-card',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加旧运动时卡
 */
export async function addThinkOldCard(data: ThinkOldCard) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-old-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改旧运动时卡
 */
export async function updateThinkOldCard(data: ThinkOldCard) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-old-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除旧运动时卡
 */
export async function removeThinkOldCard(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-old-card/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除旧运动时卡
 */
export async function removeBatchThinkOldCard(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-old-card/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询旧运动时卡
 */
export async function getThinkOldCard(id: number) {
  const res = await request.get<ApiResult<ThinkOldCard>>(
    THINK_API_URL + '/think/think-old-card/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
